
--===========================================================
-- BigFootBar 汾 1.1
-- ߣ Andy Xiao
-- ڣ 20041218
--  BigFootBarṩɶƵĶ⶯ҷöť
--
-- ģȨAndyXiao@WoWInside.Net
--===========================================================

-- öťID
function BigFootActionButton_GetPagedID(button)
	if( button == nil ) then
		message("nil button passed into SecondActionButton_GetPagedID(), contact Jeff");
		return 0;
	end
	-- this doesnt seem to work with stances
	--if (CURRENT_ACTIONBAR_PAGE == NUM_ACTIONBAR_PAGES) then
	--	return (button:GetId());
	--end
	
--	local actualPage = math.mod(CURRENT_ACTIONBAR_PAGE-1,NUM_ACTIONBAR_PAGES) +1;
	
	-- had to change this to handle different page bys
--	return (button:GetID() + ((actualPage - 1) * NUM_ACTIONBAR_BUTTONS) + 12);
	return button:GetID();
end

-- ðťTooltip
function BigFootActionButton_SetTooltip(button)
	if ( not button ) then
		button = this;
	end

	if ( GetCVar("UberTooltips") == "1" ) then
		GameTooltip_SetDefaultAnchor(GameTooltip, button);
	else
		GameTooltip:SetOwner(button, "ANCHOR_RIGHT");
	end
	
	if ( GameTooltip:SetAction(BigFootActionButton_GetPagedID(button)) ) then
		button.updateTooltip = TOOLTIP_UPDATE_TIME;
	else
		button.updateTooltip = nil;
	end
end

-- ¼Ӧ
function BigFootActionButton_OnEvent(event)
	if ( event == "ACTIONBAR_SLOT_CHANGED" ) then
		if ( arg1 == -1 or arg1 == BigFootActionButton_GetPagedID(this) ) then
			BigFootActionButton_Update();
		end
		return;
	end
	if ( event == "ACTIONBAR_PAGE_CHANGED" or event == "PLAYER_AURAS_CHANGED" or event == "UPDATE_BONUS_ACTIONBAR" ) then
		BigFootActionButton_Update();
		BigFootActionButton_UpdateState();
		return;
	end
	if ( event == "ACTIONBAR_SHOWGRID" ) then
		BigFootActionButton_ShowGrid();
		return;
	end
	if ( event == "ACTIONBAR_HIDEGRID" ) then
		BigFootActionButton_HideGrid();
		return;
	end
	if ( event == "UPDATE_BINDINGS" ) then
		BigFootActionButton_UpdateHotkeys();
	end

	-- All event handlers below this line MUST only be valid when the button is visible
	if ( not this:IsVisible() ) then
		return;
	end

	if ( event == "PLAYER_TARGET_CHANGED" ) then
		BigFootActionButton_UpdateUsable();
		return;
	end
	if ( event == "UNIT_AURASTATE" ) then
		if ( arg1 == "player" or arg1 == "target" ) then
			BigFootActionButton_UpdateUsable();
		end
		return;
	end
	if ( event == "UNIT_INVENTORY_CHANGED" ) then
		if ( arg1 == "player" ) then
			BigFootActionButton_Update();
		end
		return;
	end
	if ( event == "ACTIONBAR_UPDATE_STATE" ) then
		BigFootActionButton_UpdateState();
		return;
	end
	if ( event == "ACTIONBAR_UPDATE_USABLE" or event == "UPDATE_INVENTORY_ALERTS" or event == "ACTIONBAR_UPDATE_COOLDOWN" ) then
		BigFootActionButton_UpdateUsable();
		BigFootActionButton_UpdateCooldown();
		return;
	end
	if ( event == "CRAFT_SHOW" or event == "CRAFT_CLOSE" or event == "TRADE_SKILL_SHOW" or event == "TRADE_SKILL_CLOSE" ) then
		BigFootActionButton_UpdateState();
		return;
	end
	if ( arg1 == "player" and (event == "UNIT_HEALTH" or event == "UNIT_MANA" or event == "UNIT_RAGE" or event == "UNIT_FOCUS" or event == "UNIT_ENERGY") ) then
		BigFootActionButton_UpdateUsable();
		return;
	end
	if ( event == "PLAYER_ENTER_COMBAT" ) then
		IN_ATTACK_MODE = 1;
		if ( IsAttackAction(BigFootActionButton_GetPagedID(this)) ) then
			BigFootActionButton_StartFlash();
		end
		return;
	end
	if ( event == "PLAYER_LEAVE_COMBAT" ) then
		IN_ATTACK_MODE = nil;
		if ( IsAttackAction(BigFootActionButton_GetPagedID(this)) ) then
			BigFootActionButton_StopFlash();
		end
		return;
	end
	if ( event == "PLAYER_COMBO_POINTS" ) then
		BigFootActionButton_UpdateUsable();
		return;
	end
	if ( event == "START_AUTOREPEAT_SPELL" ) then
		IN_AUTOREPEAT_MODE = 1;
		if ( IsAutoRepeatAction(ActionButton_GetPagedID(this)) ) then
			BigFootActionButton_StartFlash();
		end
		return;
	end
	if ( event == "STOP_AUTOREPEAT_SPELL" ) then
		IN_AUTOREPEAT_MODE = nil;
		if ( BigFootActionButton_IsFlashing() and not IsAttackAction(BigFootActionButton_GetPagedID(this)) ) then
			BigFootActionButton_StopFlash();
		end
		return;
	end
end

-- ʼ
function BigFootActionButton_StartFlash(button)
	if ( not button ) then
		button = this;
	end

	button.flashing = 1;
	button.flashtime = 0;
	BigFootActionButton_UpdateState(button);
end

-- ֹͣ
function BigFootActionButton_StopFlash(button)
	if ( not button ) then
		button = this;
	end

	button.flashing = 0;
	getglobal(button:GetName().."Flash"):Hide();
	BigFootActionButton_UpdateState(button);
end

-- Ƿ
function BigFootActionButton_IsFlashing(button)
	if ( not button ) then
		button = this;
	end

	if ( button.flashing == 1 ) then
		return 1;
	else
		return nil;
	end
end

-- handler
function BigFootActionButton_OnUpdate(elapsed)
	-- ťҪЧ
	if ( ActionButton_IsFlashing() ) then
		this.flashtime = this.flashtime - elapsed;
		if ( this.flashtime <= 0 ) then
			local overtime = -this.flashtime;
			if ( overtime >= ATTACK_BUTTON_FLASH_TIME ) then
				overtime = 0;
			end
			this.flashtime = ATTACK_BUTTON_FLASH_TIME - overtime;

			local flashTexture = getglobal(this:GetName().."Flash");
			if ( flashTexture:IsVisible() ) then
				flashTexture:Hide();
			else
				flashTexture:Show();
			end
		end
	end
	
	-- ť÷Χָʾ
	-- Handle range indicator
	if ( this.rangeTimer ) then
		if ( this.rangeTimer < 0 ) then
			local count = getglobal(this:GetName().."HotKey");

-- Added By AndyXiao, * BEGIN *
			local icon = getglobal(this:GetName().."Icon");
-- Added By AndyXiao, * END *

			if ( IsActionInRange( BigFootActionButton_GetPagedID(this)) == 0 ) then

-- Added By AndyXiao, * BEGIN *
				if ( BigFoot_DistanceAlert ) then
					icon:SetVertexColor(BigFoot_DistanceAlert.color.r, BigFoot_DistanceAlert.color.g, BigFoot_DistanceAlert.color.b);
				end
-- Added By AndyXiao, * END *

				count:SetVertexColor(1.0, 0.1, 0.1);
			else

-- Added By AndyXiao, * BEGIN *
				if ( BigFoot_DistanceAlert ) then
					BigFootActionButton_UpdateUsable();
				end
-- Added By AndyXiao, * END *

				count:SetVertexColor(0.6, 0.6, 0.6);
			end
			this.rangeTimer = TOOLTIP_UPDATE_TIME;
		else
			this.rangeTimer = this.rangeTimer - elapsed;
		end
	end

	-- ҪʾԻֱӽ
	if ( not this.updateTooltip ) then
		return;
	end

	-- ʾԻϢ
	this.updateTooltip = this.updateTooltip - elapsed;
	if ( this.updateTooltip > 0 ) then
		return;
	end

	if ( GameTooltip:IsOwned(this) ) then
		BigFootActionButton_SetTooltip();
	else
		this.updateTooltip = nil;
	end
end

-- ¶ťʾֵ
function BigFootActionButton_UpdateCount(button)
	if ( not button ) then
		button = this;
	end

	local text = getglobal(button:GetName().."Count");
	local count = GetActionCount(BigFootActionButton_GetPagedID(button));
	if ( count > 1 ) then
		text:SetText(count);
	else
		text:SetText("");
	end
end

-- ¶ťġЧ״̬
function BigFootActionButton_UpdateUsable(button)
	if ( not button ) then
		button = this;
	end

	local icon = getglobal(button:GetName().."Icon");
	local normalTexture = getglobal(button:GetName().."NormalTexture");
	local isUsable, notEnoughMana = IsUsableAction(BigFootActionButton_GetPagedID(button));
	if ( isUsable ) then
		
-- Modified By Andyxiao * BEGIN *
		if (  BigFoot_DistanceAlert and IsActionInRange( BigFootActionButton_GetPagedID(this)) == 0 ) then
			icon:SetVertexColor(BigFoot_DistanceAlert.color.r, BigFoot_DistanceAlert.color.g, BigFoot_DistanceAlert.color.b);
		else	
			icon:SetVertexColor(1.0, 1.0, 1.0);
		end
		normalTexture:SetVertexColor(1.0, 1.0, 1.0);
	elseif ( notEnoughMana ) then
		if (  BigFoot_DistanceAlert and IsActionInRange( BigFootActionButton_GetPagedID(this)) == 0 ) then
			icon:SetVertexColor(BigFoot_DistanceAlert.color.r, BigFoot_DistanceAlert.color.g, BigFoot_DistanceAlert.color.b);
		else	
			icon:SetVertexColor(0.5, 0.5, 1.0);
		end
		normalTexture:SetVertexColor(0.5, 0.5, 1.0);
	else
		if (  BigFoot_DistanceAlert and IsActionInRange( BigFootActionButton_GetPagedID(this)) == 0 ) then
			icon:SetVertexColor(BigFoot_DistanceAlert.color.r, BigFoot_DistanceAlert.color.g, BigFoot_DistanceAlert.color.b);
		else	
			icon:SetVertexColor(0.4, 0.4, 0.4);
		end
-- Modified By AndyXiao * END *

		normalTexture:SetVertexColor(1.0, 1.0, 1.0);
	end
end

-- °ťġ״̬
function BigFootActionButton_UpdateState(button)
	if ( not button ) then
		button = this;
	end

	if ( IsCurrentAction(BigFootActionButton_GetPagedID(button)) or IsAutoRepeatAction(BigFootActionButton_GetPagedID(button)) ) then
		button:SetChecked(1);
	else
		button:SetChecked(0);
	end
end

-- ʾťı߿
function BigFootActionButton_ShowGrid(button)
	if ( not button ) then
		button = this;
	end

	button.showgrid = button.showgrid+1;
	getglobal(button:GetName().."NormalTexture"):SetVertexColor(1.0, 1.0, 1.0);

	if ( (button.showgrid ~= 0 or not BigFootBar_Option_HideGrid) and not button.hide and not button.minimized ) then
		button:Show();
	end
end

-- ذťı߿
function BigFootActionButton_HideGrid(button)	
	if ( not button ) then
		button = this;
	end

	button.showgrid = button.showgrid-1;

	if ( button.showgrid == 0 and BigFootBar_Option_HideGrid and not HasAction(BigFootActionButton_GetPagedID(button)) ) then
		button:Hide();
	end
end

function BigFootActionButton_UpdateState(button)
	if ( not button ) then
		button = this;
	end

	if ( IsCurrentAction(BigFootActionButton_GetPagedID(button)) or IsAutoRepeatAction(BigFootActionButton_GetPagedID(button)) ) then
		button:SetChecked(1);
	else
		button:SetChecked(0);
	end
end

function BigFootActionButton_UpdateFlash(button)
	if ( not button ) then
		button = this;
	end
	local pagedID = BigFootActionButton_GetPagedID(button);

	if ( (IsAttackAction(pagedID) and IsCurrentAction(pagedID)) or IsAutoRepeatAction(pagedID) ) then
		BigFootActionButton_StartFlash(button);
	else
		BigFootActionButton_StopFlash(button);
	end
end

-- °ť
function BigFootActionButton_Update(button)
	if ( not button ) then
		button = this;
	end

	local pagedID = BigFootActionButton_GetPagedID(button);
	
	-- Զ⶯ť
	-- ⶯ťڴڶ״ֹ̬ť
	-- Special case code for bonus bar buttons
	-- Prevents the button from updating if the bonusbar is still in an animation transition

	-- Derek, I had to comment this out because it was causing them all to be grayed out after a cinematic...
	if ( button.isBonus and button.inTransition ) then
		BigFootActionButton_UpdateUsable(button);
		BigFootActionButton_UpdateCooldown(button);
		return;
	end
	
	-- ʾťͼ
	local icon = getglobal(button:GetName().."Icon");
	local buttonCooldown = getglobal(button:GetName().."Cooldown");
	local texture = GetActionTexture(pagedID);
	if ( texture ) then
		icon:SetTexture(texture);
		icon:Show();
		button.rangeTimer = TOOLTIP_UPDATE_TIME;
		button:SetNormalTexture("Interface\\Buttons\\UI-Quickslot2");
		-- Save texture if the button is a bonus button, will be needed later
		if ( button.isBonus ) then
			button.texture = texture;
		end
	else
		icon:Hide();
		buttonCooldown:Hide();
		button.rangeTimer = nil;
		button:SetNormalTexture("Interface\\Buttons\\UI-Quickslot");
		getglobal(button:GetName().."HotKey"):SetVertexColor(0.6, 0.6, 0.6);
	end

	-- °ť
	BigFootActionButton_UpdateCount(button);

	-- ðťڶҪ¿״̬ȴʱ
	if ( HasAction(pagedID) and not button.hide ) then
		BigFootActionButton_UpdateState(button);
		BigFootActionButton_UpdateUsable(button);
		BigFootActionButton_UpdateCooldown(button);
		BigFootActionButton_UpdateFlash(button);
	elseif ( this.showgrid == 0 and BigFootBar_Option_HideGrid ) then
		button:Hide();
	else
		getglobal(button:GetName().."Cooldown"):Hide();
	end

	-- ðťһװ߿Ϊɫ
	local border = getglobal(button:GetName().."Border");
	if ( IsEquippedAction(BigFootActionButton_GetPagedID(this)) ) then
		border:SetVertexColor(0, 1.0, 0, 0.35);
		border:Show();
	else
		border:Hide();
	end

	if ( GameTooltip:IsOwned(button) ) then
		BigFootActionButton_SetTooltip(button);
	else
		button.updateTooltip = nil;
	end

	-- Update Macro Text
	local macroName = getglobal(button:GetName().."Name");
	macroName:SetText(GetActionText(BigFootActionButton_GetPagedID(button)));
end

-- ȼťϢ
function BigFootActionButton_UpdateHotkeys(actionButtonType, button)
	if ( not button ) then
		button = this;
	end

	if ( not actionButtonType ) then
		actionButtonType = "ACTIONBUTTON";
	end
	local hotkey = getglobal(button:GetName().."HotKey");
	local action = actionButtonType..button:GetID();
	hotkey:SetText(GetBindingText(GetBindingKey(action), "KEY_"));
end

-- ʼҪע¼Ϣ
function BigFootActionButton_OnLoad()
	this.showgrid = 0;
	this.flashing = 0;
	this.flashtime = 0;
	BigFootActionButton_Update();
	this:RegisterForDrag("LeftButton", "RightButton");
	this:RegisterForClicks("LeftButtonUp", "RightButtonUp");
	this:RegisterEvent("ACTIONBAR_SHOWGRID");
	this:RegisterEvent("ACTIONBAR_HIDEGRID");
	this:RegisterEvent("ACTIONBAR_PAGE_CHANGED");
	this:RegisterEvent("ACTIONBAR_SLOT_CHANGED");
	this:RegisterEvent("ACTIONBAR_UPDATE_STATE");
	this:RegisterEvent("ACTIONBAR_UPDATE_USABLE");
	this:RegisterEvent("ACTIONBAR_UPDATE_COOLDOWN");
	this:RegisterEvent("UPDATE_INVENTORY_ALERTS");
	this:RegisterEvent("PLAYER_AURAS_CHANGED");
	this:RegisterEvent("PLAYER_TARGET_CHANGED");
	this:RegisterEvent("UNIT_AURASTATE");
	this:RegisterEvent("UNIT_INVENTORY_CHANGED");
	this:RegisterEvent("CRAFT_SHOW");
	this:RegisterEvent("CRAFT_CLOSE");
	this:RegisterEvent("TRADE_SKILL_SHOW");
	this:RegisterEvent("TRADE_SKILL_CLOSE");
	this:RegisterEvent("UNIT_HEALTH");
	this:RegisterEvent("UNIT_MANA");
	this:RegisterEvent("UNIT_RAGE");
	this:RegisterEvent("UNIT_FOCUS");
	this:RegisterEvent("UNIT_ENERGY");
	this:RegisterEvent("UPDATE_BONUS_ACTIONBAR");
	this:RegisterEvent("PLAYER_ENTER_COMBAT");
	this:RegisterEvent("PLAYER_LEAVE_COMBAT");
	this:RegisterEvent("PLAYER_COMBO_POINTS");
	this:RegisterEvent("UPDATE_BINDINGS");
	this:RegisterEvent("START_AUTOREPEAT_SPELL");
	this:RegisterEvent("STOP_AUTOREPEAT_SPELL");
	BigFootActionButton_UpdateHotkeys();

	getglobal(this:GetName().."NormalTexture"):SetAlpha(0.5);
	getglobal(this:GetName().."PushedTexture"):SetAlpha(0.5);
	getglobal(this:GetName().."HighlightTexture"):SetAlpha(0.5);
	getglobal(this:GetName().."CheckedTexture"):SetAlpha(0.5);
end

-- ¶ťȴʱ
function BigFootActionButton_UpdateCooldown(button)
	if ( not button ) then
		button = this;
	end

	local cooldown = getglobal(button:GetName().."Cooldown");
	local start, duration, enable = GetActionCooldown(BigFootActionButton_GetPagedID(button));
	CooldownFrame_SetTimer(cooldown, start, duration, enable);
end

