-------------------------------------------------------------------------------
-- the constants for the mod (non localized)
-------------------------------------------------------------------------------
DCR_VERSION_STRING = "Decursive 1.9.0";

DCR_MACRO_COMMAND  = "/decursive";
DCR_MACRO_SHOW     = "/dcrshow";

DCR_MACRO_PRADD    = "/dcrpradd";
DCR_MACRO_PRCLEAR  = "/dcrprclear";
DCR_MACRO_PRLIST   = "/dcrprlist";
DCR_MACRO_PRSHOW   = "/dcrprshow";

DCR_MACRO_SKADD    = "/dcrskadd";
DCR_MACRO_SKCLEAR  = "/dcrskclear";
DCR_MACRO_SKLIST   = "/dcrsklist";
DCR_MACRO_SKSHOW   = "/dcrskshow";

if (GetLocale() == "zhCN") then
	DCR_MOD_NOT_ENABLED = '一键驱散功能没有开启，请在设置面板的<团队工具>中开启该功能。';

	DCR_CLASS_DRUID   = '德鲁伊';
	DCR_CLASS_HUNTER  = '猎人';
	DCR_CLASS_MAGE    = '法师';
	DCR_CLASS_PALADIN = '圣骑士';
	DCR_CLASS_PRIEST  = '牧师';
	DCR_CLASS_ROGUE   = '盗贼';
	DCR_CLASS_SHAMAN  = '萨满祭司';
	DCR_CLASS_WARLOCK = '术士';
	DCR_CLASS_WARRIOR = '战士';

	DCR_DISEASE = '疾病';
	DCR_MAGIC   = '魔法';
	DCR_POISON  = '中毒';
	DCR_CURSE   = '诅咒';
	DCR_CHARMED = '魅惑';

	DCR_PET_FELHUNTER = "地狱犬";
	DCR_PET_DOOMGUARD = "末日守卫";
	DCR_PET_FEL_CAST  = "吞噬魔法";
	DCR_PET_DOOM_CAST = "驱散魔法";

	DCR_SPELL_CURE_DISEASE        = '祛病术';
	DCR_SPELL_ABOLISH_DISEASE     = '驱除疾病';
	DCR_SPELL_PURIFY              = '纯净术';
	DCR_SPELL_CLEANSE             = '清洁术';
	DCR_SPELL_DISPELL_MAGIC       = '驱散魔法';
	DCR_SPELL_CURE_POISON         = '消毒术';
	DCR_SPELL_ABOLISH_POISON      = '驱毒术';
	DCR_SPELL_REMOVE_LESSER_CURSE = '解除次级诅咒';
	DCR_SPELL_REMOVE_CURSE        = '解除诅咒';
	DCR_SPELL_PURGE               = '净化术';
	DCR_SPELL_NO_RANK             = '';
	DCR_SPELL_RANK_1              = '等级 1';
	DCR_SPELL_RANK_2              = '等级 2';

	BINDING_HEADER_DECURSIVE = "一键驱散";

	BINDING_NAME_DCRCLEAN   = "一键驱散";
	BINDING_NAME_DCRSHOW    = "显示或隐藏带不良效果者列表";

	BINDING_NAME_DCRPRADD     = "将目标添加到优先列表";
	BINDING_NAME_DCRPRCLEAR = "清空优先列表";
	BINDING_NAME_DCRPRLIST  = "显示优先列表内容";
	BINDING_NAME_DCRPRSHOW  = "显示/隐藏优先列表";

	BINDING_NAME_DCRSKADD   = "将目标添加到忽略列表";
	BINDING_NAME_DCRSKCLEAR = "清空忽略列表";
	BINDING_NAME_DCRSKLIST  = "显示忽略列表内容";
	BINDING_NAME_DCRSKSHOW  = "显示/隐藏忽略列表";

	DCR_PRIORITY_LIST = "一键驱散 优先列表";
	DCR_SKIP_LIST_STR  = "一键驱散 忽略列表";
	DCR_SKIP_OPT_STR   = "一键驱散 选项设置";
	DCR_POPULATE_LIST  = "快速弹出一键驱散列表";
	DCR_RREMOVE_ID     = "点击移除这个玩家";
	DCR_HIDE_MAIN      = "隐藏活动列表";
	DCR_RESHOW_MSG     = "要重新显示活动列表，请输入/dcrshow";

	DCR_PRINT_CHATFRAME = "在默认聊天窗口显示信息";
	DCR_PRINT_CUSTOM    = "在独立窗口中显示";
	DCR_PRINT_ERRORS    = "显示错误信息";
	DCR_AMOUNT_AFFLIC   = "可显示的不良效果数量：";
	DCR_BLACK_LENGTH    = "在黑名单上存在的秒数：";
	DCR_SCAN_LENGTH     = "搜索间隔秒数：";
	DCR_ABOLISH_CHECK   = "在驱散前检查已有驱散效果";
	DCR_BEST_SPELL      = "总是使用最高级的法术";
	DCR_RANDOM_ORDER    = "随机顺序治疗";
	DCR_CURE_PETS       = "搜索并治疗宠物";
	DCR_IGNORE_STEALTH  = "忽略潜行的目标";
	DCR_ANCHOR          = "一键驱散文字停靠";
	
	DCR_NAME			= "名字";
	DCR_AFFLICTION		= "不良效果";
	DCR_ASSISTANT		= "辅助";
	DCR_DECURSIVE		= "一键驱散";
	DCR_PRIORITY		= "一键驱散 优先列表";
	DCR_SKIP			= "一键驱散 忽略列表";
	DCR_QUICKLY_POP		= "快速弹出";
	DCR_POP_LIST		= "弹出列表";
	DCR_GROUP_1			= "队伍 1";
	DCR_GROUP_2			= "队伍 2";
	DCR_GROUP_3			= "队伍 3";
	DCR_GROUP_4			= "队伍 4";
	DCR_GROUP_5			= "队伍 5";
	DCR_GROUP_6			= "队伍 6";
	DCR_GROUP_7			= "队伍 7";
	DCR_GROUP_8			= "队伍 8";
	DCR_OTHER			= "其他";
	DCR_CLOSE			= "关闭";
	DCR_OPTIONS			= "选项";

	-- $s is spell name
	-- $a is affliction name/type
	-- $t is target name
	DCR_DISPELL_ENEMY    = "对敌人施放了'$s'！";
	DCR_NOT_CLEANED      = "未驱散任何效果";
	DCR_CLEAN_STRING     = "对$t施放$s以驱散$a效果";
	DCR_SPELL_FOUND      = "发现$s法术！";
	DCR_NO_SPELLS        = "未发现可以驱散不良效果的法术！";
	DCR_NO_SPELLS_RDY    = "可以驱散不良效果的法术还未准备好！";
	DCR_OUT_OF_RANGE     = "目标距离太远，$t的$a效果无法被驱散！";
	DCR_IGNORE_STRING    = "忽略$t身上的$a效果……";

	DCR_INVISIBLE_LIST = {
		["潜伏"]       = true,
		["潜行"]     = true,
		["影遁"]  = true,
	}

	-- this causes the target to be ignored!!!!
	DCR_IGNORELIST = {
		["放逐术"]      = true,
		["相位变换"] = true,
	};

	-- ignore this effect
	DCR_SKIP_LIST = {
		["无梦睡眠"] = true,
		["强效昏睡"] = true,
		["心灵视界"] = true,
	};

	-- ignore the effect bassed on the class
	DCR_SKIP_BY_CLASS_LIST = {
		[DCR_CLASS_WARRIOR] = {
			["上古狂乱"]   = true,
			["点燃法力"]   = true,
			["污浊之魂"]   = true,
		};
		[DCR_CLASS_ROGUE] = {
			["沉默"]       = true;
			["上古狂乱"]   = true,
			["点燃法力"]   = true,
			["污浊之魂"]   = true,
		};
		[DCR_CLASS_HUNTER] = {
			["熔岩镣铐"]   = true,
		};
		[DCR_CLASS_MAGE] = {
			["熔岩镣铐"]  = true,
		};
	};
elseif (GetLocale() == "zhTW") then
	DCR_MOD_NOT_ENABLED = '一鍵驅散功能沒有開啓，請在設置面板的<團隊工具>中開啓該功能';

	DCR_CLASS_DRUID   = '德魯伊';
	DCR_CLASS_HUNTER  = '獵人';
	DCR_CLASS_MAGE    = '法師';
	DCR_CLASS_PALADIN = '聖騎士';
	DCR_CLASS_PRIEST  = '牧師';
	DCR_CLASS_ROGUE   = '盜賊';
	DCR_CLASS_SHAMAN  = '薩滿';
	DCR_CLASS_WARLOCK = '術士';
	DCR_CLASS_WARRIOR = '戰士';

	DCR_DISEASE = '疾病';
	DCR_MAGIC   = '魔法';
	DCR_POISON  = '中毒';
	DCR_CURSE   = '詛咒';
	DCR_CHARMED = '魅惑';

	DCR_PET_FELHUNTER = "地獄犬";
	DCR_PET_DOOMGUARD = "末日守衛";
	DCR_PET_FEL_CAST  = "吞噬魔法";
	DCR_PET_DOOM_CAST = "驅散魔法";

	DCR_SPELL_CURE_DISEASE        = '祛病術';
	DCR_SPELL_ABOLISH_DISEASE     = '驅除疾病';
	DCR_SPELL_PURIFY              = '純淨術';
	DCR_SPELL_CLEANSE             = '清潔術';
	DCR_SPELL_DISPELL_MAGIC       = '驅散魔法';
	DCR_SPELL_CURE_POISON         = '消毒術';
	DCR_SPELL_ABOLISH_POISON      = '驅毒術';
	DCR_SPELL_REMOVE_LESSER_CURSE = '解除次級詛咒';
	DCR_SPELL_REMOVE_CURSE        = '解除詛咒';
	DCR_SPELL_PURGE               = '淨化術';
	DCR_SPELL_NO_RANK             = '';
	DCR_SPELL_RANK_1              = '等級 1';
	DCR_SPELL_RANK_2              = '等級 2';

	BINDING_HEADER_DECURSIVE = "一鍵驅散";

	BINDING_NAME_DCRCLEAN   = "一鍵驅散";
	BINDING_NAME_DCRSHOW    = "顯示或隱藏帶傷害魔法者列表";

	BINDING_NAME_DCRPRADD     = "添加優先目標";
	BINDING_NAME_DCRPRCLEAR = "清空優先列表";
	BINDING_NAME_DCRPRLIST  = "顯示優先列表內容";
	BINDING_NAME_DCRPRSHOW  = "顯示/隱藏優先列表界面";

	BINDING_NAME_DCRSKADD   = "添加忽視目標";
	BINDING_NAME_DCRSKCLEAR = "清空忽視列表";
	BINDING_NAME_DCRSKLIST  = "顯示忽視列表內容";
	BINDING_NAME_DCRSKSHOW  = "顯示/隱藏忽視列表界面";

	DCR_PRIORITY_LIST = "一鍵驅散 優先列表";
	DCR_SKIP_LIST_STR  = "一鍵驅散 忽視列表";
	DCR_SKIP_OPT_STR   = "一鍵驅散 選項設置";
	DCR_POPULATE_LIST  = "快速彈出一鍵驅散列表";
	DCR_RREMOVE_ID     = "移除這個玩家";
	DCR_HIDE_MAIN      = "隱藏活動列表";
	DCR_RESHOW_MSG     = "爲了能夠重新顯示活動列表，請輸入/dcrshow";

	DCR_PRINT_CHATFRAME = "在缺省聊天窗口顯示消息";
	DCR_PRINT_CUSTOM    = "在這個窗口顯示消息";
	DCR_PRINT_ERRORS    = "顯示錯誤消息";
	DCR_AMOUNT_AFFLIC   = "可顯示的傷害魔法數量：";
	DCR_BLACK_LENGTH    = "在黑名單上存在的秒數：";
	DCR_SCAN_LENGTH     = "搜索間隔秒數：";
	DCR_ABOLISH_CHECK   = "在治愈之前檢查驅散效果";
	DCR_BEST_SPELL      = "總是使用最高級的魔法。";
	DCR_RANDOM_ORDER    = "隨機順序治療";
	DCR_CURE_PETS       = "搜索並治療寵物";
	DCR_IGNORE_STEALTH  = "忽略潛行的目標";
	DCR_ANCHOR          = "一鍵驅散文字停靠";

	DCR_NAME			= "名字";
	DCR_AFFLICTION		= "痛苦";
	DCR_ASSISTANT		= "助手";
	DCR_DECURSIVE		= "一鍵驅散";
	DCR_PRIORITY		= "一鍵驅散 優先列表";
	DCR_SKIP			= "一鍵驅散 忽略列表";
	DCR_QUICKLY_POP		= "快速彈出";
	DCR_POP_LIST		= "彈出列表";
	DCR_GROUP_1			= "隊伍 1";
	DCR_GROUP_2			= "隊伍 2";
	DCR_GROUP_3			= "隊伍 3";
	DCR_GROUP_4			= "隊伍 4";
	DCR_GROUP_5			= "隊伍 5";
	DCR_GROUP_6			= "隊伍 6";
	DCR_GROUP_7			= "隊伍 7";
	DCR_GROUP_8			= "隊伍 8";
	DCR_OTHER			= "其他";
	DCR_CLOSE			= "關閉";
	DCR_OPTIONS			= "選項";
	
	-- $s is spell name
	-- $a is affliction name/type
	-- $t is target name
	DCR_DISPELL_ENEMY    = "對敵人施放了'$s'！";
	DCR_NOT_CLEANED      = "未驅散任何效果";
	DCR_CLEAN_STRING     = "對$t施放$s以驅散$a效果";
	DCR_SPELL_FOUND      = "發現$s法術！";
	DCR_NO_SPELLS        = "未發現可以驅散不良效果的法術！";
	DCR_NO_SPELLS_RDY    = "可以驅散不良效果的法術還未准備好！";
	DCR_OUT_OF_RANGE     = "目標距離太遠，$t的$a效果無法被驅散！";
	DCR_IGNORE_STRING    = "忽略$t身上的$a效果……";

	DCR_INVISIBLE_LIST = {
		["潛伏"]       = true,
		["潛行"]     = true,
		["影遁"]  = true,
	}

	-- this causes the target to be ignored!!!!
	DCR_IGNORELIST = {
		["放逐術"]      = true,
		["相位變換"] = true,
	};

	-- ignore this effect
	DCR_SKIP_LIST = {
		["無夢睡眠"] = true,
		["強效昏睡"] = true,
		["心靈視界"] = true,
	};

	-- ignore the effect bassed on the class
	DCR_SKIP_BY_CLASS_LIST = {
		[DCR_CLASS_WARRIOR] = {
			["上古狂亂"]   = true,
			["點燃法力"]   = true,
			["汙濁之魂"]   = true,
		};
		[DCR_CLASS_ROGUE] = {
			["沈默"]       = true;
			["上古狂亂"]   = true,
			["點燃法力"]   = true,
			["汙濁之魂"]   = true,
		};
		[DCR_CLASS_HUNTER] = {
			["熔岩鐐铐"]   = true,
		};
		[DCR_CLASS_MAGE] = {
			["熔岩鐐铐"]  = true,
		};
	};
else
	DCR_MOD_NOT_ENABLED = 'Decursive is not enabled. Please enable it in Raid tools in settings.';

	DCR_CLASS_DRUID   = 'Druid';
	DCR_CLASS_HUNTER  = 'Hunter';
	DCR_CLASS_MAGE    = 'Mage';
	DCR_CLASS_PALADIN = 'Paladin';
	DCR_CLASS_PRIEST  = 'Priest';
	DCR_CLASS_ROGUE   = 'Rogue';
	DCR_CLASS_SHAMAN  = 'Shaman';
	DCR_CLASS_WARLOCK = 'Warlock';
	DCR_CLASS_WARRIOR = 'Warrior';

	DCR_DISEASE = 'Disease';
	DCR_MAGIC   = 'Magic';
	DCR_POISON  = 'Poison';
	DCR_CURSE   = 'Curse';
	DCR_CHARMED = 'Charm';

	DCR_PET_FELHUNTER = "Felhunter";
	DCR_PET_DOOMGUARD = "Doomguard";
	DCR_PET_FEL_CAST  = "Devour Magic";
	DCR_PET_DOOM_CAST = "Dispel Magic";

	DCR_SPELL_CURE_DISEASE        = 'Cure Disease';
	DCR_SPELL_ABOLISH_DISEASE     = 'Abolish Disease';
	DCR_SPELL_PURIFY              = 'Purify';
	DCR_SPELL_CLEANSE             = 'Cleanse';
	DCR_SPELL_DISPELL_MAGIC       = 'Dispel Magic';
	DCR_SPELL_CURE_POISON         = 'Cure Poison';
	DCR_SPELL_ABOLISH_POISON      = 'Abolish Poison';
	DCR_SPELL_REMOVE_LESSER_CURSE = 'Remove Lesser Curse';
	DCR_SPELL_REMOVE_CURSE        = 'Remove Curse';
	DCR_SPELL_PURGE               = 'Purge';
	DCR_SPELL_NO_RANK             = '';
	DCR_SPELL_RANK_1              = 'Rank 1';
	DCR_SPELL_RANK_2              = 'Rank 2';

	BINDING_HEADER_DECURSIVE = "Decursive";
	
	BINDING_NAME_DCRCLEAN   = "Clean Group";
	BINDING_NAME_DCRSHOW    = "Show or hide the afflicted list";

	BINDING_NAME_DCRPRADD     = "Add target to priority list";
	BINDING_NAME_DCRPRCLEAR   = "Clear the priority list";
	BINDING_NAME_DCRPRLIST    = "Print the priority list";
	BINDING_NAME_DCRPRSHOW    = "Show or hide the priority list";

	BINDING_NAME_DCRSKADD   = "Add target to skip list";
	BINDING_NAME_DCRSKCLEAR = "Clear the skip list";
	BINDING_NAME_DCRSKLIST  = "Print the skip list";
	BINDING_NAME_DCRSKSHOW  = "Show or hide the skip list";

	DCR_PRIORITY_LIST  = "Decursive Priority List";
	DCR_SKIP_LIST_STR  = "Decursive Skip List";
	DCR_SKIP_OPT_STR   = "Decursive Options Menu";
	DCR_POPULATE_LIST  = "Quickly populate the Decursive list";
	DCR_RREMOVE_ID     = "Remove this player";
	DCR_HIDE_MAIN      = "Hide live list";
	DCR_RESHOW_MSG     = "To reshow the live list, type /dcrshow";

	DCR_PRINT_CHATFRAME = "Print messages in default chat";
	DCR_PRINT_CUSTOM    = "Print messages in the window";
	DCR_PRINT_ERRORS    = "Print error messages";
	DCR_AMOUNT_AFFLIC   = "The amount of afflicted to show : ";
	DCR_BLACK_LENGTH    = "Seconds on the blacklist : ";
	DCR_SCAN_LENGTH     = "Seconds in between live scans : ";
	DCR_ABOLISH_CHECK   = "Check for Abolish before curing";
	DCR_BEST_SPELL      = "Always use the highest spell rank.";
	DCR_RANDOM_ORDER    = "Cure in a random order";
	DCR_CURE_PETS       = "Scan and cure pets";
	DCR_IGNORE_STEALTH  = "Ignore Stealthed Units";
	DCR_ANCHOR          = "Decursive Text Anchor";

	DCR_NAME			= "Name";
	DCR_AFFLICTION		= "Affliction";
	DCR_ASSISTANT		= "Assistant";
	DCR_DECURSIVE		= "Decursive";
	DCR_PRIORITY		= "Decursive Priority";
	DCR_SKIP			= "Decursive Skip";
	DCR_QUICKLY_POP		= "Quickly Populate";
	DCR_POP_LIST		= "Populate List";
	DCR_GROUP_1			= "Group 1";
	DCR_GROUP_2			= "Group 2";
	DCR_GROUP_3			= "Group 3";
	DCR_GROUP_4			= "Group 4";
	DCR_GROUP_5			= "Group 5";
	DCR_GROUP_6			= "Group 6";
	DCR_GROUP_7			= "Group 7";
	DCR_GROUP_8			= "Group 8";
	DCR_OTHER			= "Other";
	DCR_CLOSE			= "Close";
	DCR_OPTIONS			= "Options";

	-- $s is spell name
	-- $a is affliction name/type
	-- $t is target name
	DCR_DISPELL_ENEMY    = "Casting '$s' on the enemy!";
	DCR_NOT_CLEANED      = "Nothing cleaned";
	DCR_CLEAN_STRING     = "Casting $s on $t to remove $a";
	DCR_SPELL_FOUND      = "$s spell found!";
	DCR_NO_SPELLS        = "No curative spells found!";
	DCR_NO_SPELLS_RDY    = "No curative spells are ready to cast!";
	DCR_OUT_OF_RANGE     = "$t is out of range and should be cured of $a!";
	DCR_IGNORE_STRING    = "$a found on $t... ignoring";

	DCR_INVISIBLE_LIST = {
		["Prowl"]       = true,
		["Stealth"]     = true,
		["Shadowmeld"]  = true,
	}

	-- this causes the target to be ignored!!!!
	DCR_IGNORELIST = {
		["Banish"]      = true,
		["Phase Shift"] = true,
	};

	-- ignore this effect
	DCR_SKIP_LIST = {
		["Dreamless Sleep"] = true,
		["Greater Dreamless Sleep"] = true,
		["Mind Vision"] = true,
	};

	-- ignore the effect bassed on the class
	DCR_SKIP_BY_CLASS_LIST = {
		[DCR_CLASS_WARRIOR] = {
			["Ancient Hysteria"]   = true,
			["Ignite Mana"]        = true,
			["Tainted Mind"]       = true,
		};
		[DCR_CLASS_ROGUE] = {
			["Silence"]            = true;
			["Ancient Hysteria"]   = true,
			["Ignite Mana"]        = true,
			["Tainted Mind"]       = true,
		};
		[DCR_CLASS_HUNTER] = {
			["Magma Shackles"]     = true,
		};
		[DCR_CLASS_MAGE] = {
			["Magma Shackles"]     = true,
		};
	};
end
