SCT_EVENT_OPTION = "事件选项";
SCT_MISC_OPTION = "基本选项";
SCT_TEXT_OPTION = "动态文字选项";
SCT_MSGTEXT_OPTION = "静态文字选项";
SCT_WARNING_OPTION = "过低警告选项";
SCT_SPELLALERT_OPTION = "法术预警选项";
SCT_BUTTON_RESET_LABEL = "重置";
SCT_BUTTON_RESET_TIP= "恢复默认设置";
SCT_BUTTON_SAVECUSTOM_LABEL = "保存个性设置"
SCT_BUTTON_LOADCUSTOM_LABEL = "读取个性设置"

SCT_RESET_TIP = "已载入默认设置";
SCT_EVENTTYPE = {
{"关","右","左","_","静"},
{"关","上","下","_","静"},
{"关","左","右","_","静"},
{"关","左","上","右","静"},
{"关","左","右","中","静"},
{"关","左","上","右","静"},
{"关","左","右","下","静"},
}


TOOL_TIP_TEXT_SE = "选中则设置为以静态方式显示，否则以动态滚动方式显示";
SCT_PREVIEW_TEXT1 = "拖动我[静]态位置";
SCT_PREVIEW_TEXT2 = "拖动我[动]态位置";

SCT_OPTION_ANIMODE = "动画方式";
SCT_ANIMODE_TEXT = {[0] = "水平",[1] = "垂直",[2] = "抛物线",[3] = "弹出1",[4] = "弹出2",[5] = "弹出1a",[6] = "向上增强"};

--Eve nt and Damage option values
SCTOptionsFrameEventFrames = { };
SCTOptionsFrameEventFrames ["SHOWHIT"] = { title = "伤害", tooltipText = "显示你受到的伤害"};
SCTOptionsFrameEventFrames ["SHOWMISS"] = { title = "未命中", tooltipText = "显示敌人对你的攻击未命中"};
SCTOptionsFrameEventFrames ["SHOWDODGE"] = { title = "回避", tooltipText = "显示你回避敌人的攻击"};
SCTOptionsFrameEventFrames ["SHOWPARRY"] = { title = "招架", tooltipText = "显示你招架敌人的攻击"};
SCTOptionsFrameEventFrames ["SHOWBLOCK"] = { title = "格挡", tooltipText = "显示你格挡敌人的攻击"};
SCTOptionsFrameEventFrames ["SHOWRESIST"] = { title = "抵抗", tooltipText = "显示你抵抗敌人的攻击"};
SCTOptionsFrameEventFrames ["SHOWABSORB"] = { title = "吸收", tooltipText = "显示你吸收敌人的攻击"};
SCTOptionsFrameEventFrames ["SHOWCOMBATIN"] = { title = "战斗开始", tooltipText = "显示战斗开始的提示"};
SCTOptionsFrameEventFrames ["SHOWCOMBATOUT"] = { title = "战斗结束", tooltipText = "显示战斗结束的提示"};
SCTOptionsFrameEventFrames ["SHOWSPELLCRIT"] = { title = "技能致命", tooltipText = "显示你的技能致命一击造成的伤害"};
SCTOptionsFrameEventFrames ["SHOWDMGCRIT"] = { title = "普通致命", tooltipText = "显示你的普通致命一击造成的伤害"};

SCTOptionsFrameEventFrames ["SHOWSPELL"] = { title = "法术伤害", tooltipText = "显示你受到的法术伤害"};
SCTOptionsFrameEventFrames ["SHOWHEAL"] = { title = "法术治疗", tooltipText = "显示法术给你带来的治疗"};
SCTOptionsFrameEventFrames ["SHOWDEBUFF"] = { title = "不良效果", tooltipText = "显示你受到的不良效果"};
SCTOptionsFrameEventFrames ["SHOWBUFF"] = { title = "增益效果", tooltipText = "显示你受到的增益效"};
SCTOptionsFrameEventFrames ["SHOWFADE"] = { title = "效果消失", tooltipText = "显示你消失的效果"};
SCTOptionsFrameEventFrames ["SHOWPOWER"] = { title = "能量获得", tooltipText = "显示你获得的能量"};
SCTOptionsFrameEventFrames ["SHOWCOMBOPOINTS"] = { title = "连击点", tooltipText = "显示你获得的连击点数"};
SCTOptionsFrameEventFrames ["SHOWHONOR_SCT"] = { title = "获得荣誉", tooltipText = "显示你获得的荣誉点数"};
SCTOptionsFrameEventFrames ["SHOWEMOTE"] = { title = "怪物表情", tooltipText = "显示怪物表情"};
SCTOptionsFrameEventFrames ["SHOWYELL"] = { title = "怪物喊叫", tooltipText = "显示怪物喊叫"};
SCTOptionsFrameEventFrames ["RETARGET"] = { title = "目标重指定", tooltipText = "显示当你受到恐惧等丢失目标的效果后的自己重指定目标"};

SCTOptionsFrameEventFrames ["SHOWEXECUTE"] = { title = "显示斩杀", tooltipText = "目标血量低于20%时候显示斩杀，限战士和圣骑"};

SCTOptionsFrameEventFrames ["SHOWLOWHP"] = { title = "生命过低", tooltipText = "当你生命低于设定值的时候显示警告"};
SCTOptionsFrameEventFrames ["SHOWLOWMANA"] = { title = "魔法过低", tooltipText = "当你魔法低于设定值的时候显示警告"};
SCTOptionsFrameEventFrames ["SHOWSPELLALERT"] = { title = "显示法术预警", tooltipText = "当敌对生物使用法术等时显示预警信息"};

--Check Button option values
SCTOptionsFrameCheckButtons = { };
SCTOptionsFrameCheckButtons ["ENABLED"] = { title = "战斗指示器", tooltipText = "开启战斗指示器"};
SCTOptionsFrameCheckButtons ["SHOWSELF"] = { title = "标记战斗信息", tooltipText = "在战斗信息的两侧添加'*'作为标记"};
SCTOptionsFrameCheckButtons ["SHOWSPELLTIMER"] = { title = "法术预警显示施法时间", tooltipText = "法术预警后面显示施法时间，当然这个时间并不是绝对准确"};
SCTOptionsFrameCheckButtons ["SHORTALERT"] = { title = "简略方式显示预警", tooltipText = "简略方式显示，只显示法术名"};
SCTOptionsFrameCheckButtons ["SHOWSA_BEGINCAST"] = { title = "预警开始施放", tooltipText = "法术预警显示开始施放的法术"};
SCTOptionsFrameCheckButtons ["SHOWSA_CAST"] = { title = "预警施放了", tooltipText = "法术预警显示瞬发的法术"};
SCTOptionsFrameCheckButtons ["SHOWSA_GAIN"] = { title = "预警效果获得", tooltipText = "法术预警显示效果获得"};
SCTOptionsFrameCheckButtons ["DAMAGETYPE"] = { title = "显示魔法伤害类型", tooltipText = "显示你受到的魔法伤害类型，比如火焰，暗影"};
SCTOptionsFrameCheckButtons ["HEALERNAME"] = { title = "显示治疗者姓名", tooltipText = "显示你受到的治疗来自哪个玩家"};
SCTOptionsFrameCheckButtons ["CUSTOMEVENT"] = { title = "使用自定义事件", tooltipText = "自定义事件开关，如果你不用自定义事件的话建议关闭此项"};

--Slider options values
SCTOptionsFrameSliders = { };
SCTOptionsFrameSliders ["ANIMATIONSPEED"] = { title = "动画速度", minValue = 0.2, maxValue = 3, valueStep = 0.1, minText="20%", maxText="300%", tooltipText = "设置动画速度"};
SCTOptionsFrameSliders ["TEXTSIZE"] = {  title = "动态文字大小", minValue = 12, maxValue = 36, valueStep = 1, minText="小", maxText="大", tooltipText = "设置动态文字的大小"};
SCTOptionsFrameSliders ["LOWHP"] = {  title = "生命值百分比", minValue = 0.1, maxValue = 0.9, valueStep = 0.1, minText="10%", maxText="90%", tooltipText = "生命过低警告的百分比"};
SCTOptionsFrameSliders ["LOWMANA"] = {  title = "魔法值百分比", minValue = 0.1, maxValue = 0.9, valueStep = 0.1, minText="10%", maxText="90%", tooltipText = "魔法过低警告的百分比"};
SCTOptionsFrameSliders ["ALPHA"] = {  title = "透明度", minValue = 0.2, maxValue = 1, valueStep = 0.05, minText="20%", maxText="100%", tooltipText = "设置文字的透明度"};
SCTOptionsFrameSliders ["FONT"] = {  title = "字体", minValue = 1, maxValue = 4, valueStep = 1, minText="字体1", maxText="字体4", tooltipText = "设置动态文字的字体"};
SCTOptionsFrameSliders ["FONTOUTLINE"] = {  title = "字体勾边", minValue = 1, maxValue = 3, valueStep = 1, minText="细", maxText="粗", tooltipText = "将字体勾边加粗"};
SCTOptionsFrameSliders ["MESSAGESIZE"] = {  title = "静态文字大小", minValue = 12, maxValue = 36, valueStep = 1, minText="小", maxText="大", tooltipText = "设置静态方式文字尺寸的大小"};
SCTOptionsFrameSliders ["MESSAGEFONT"] = {  title = "静态文字字体", minValue = 1, maxValue = 4, valueStep = 1, minText="字体1", maxText="字体4", tooltipText = "设置静态方式文字尺寸的大小"};
SCTOptionsFrameSliders ["MESSAGEALPHA"] = {  title = "透明度", minValue = 0.2, maxValue = 1, valueStep = 0.05, minText="20%", maxText="100%", tooltipText = "设置静态方式文字的透明度"};
SCTOptionsFrameSliders ["MESSAGETIMER"] = {  title = "停留时间", minValue = 1, maxValue = 10, valueStep = 0.5, minText="1秒", maxText="10秒", tooltipText = "设置静态方式在停留时间"};
SCTOptionsFrameSliders ["MESSFONTOUTLINE"] = {  title = "静态字体勾边", minValue = 1, maxValue = 3, valueStep = 0.5, minText="细", maxText="粗", tooltipText = "设置静态方式文字的勾边"};
SCTOptionsFrameSliders ["ANIC"] = {  title = "最大显示数量", minValue = 1, maxValue = 10, valueStep = 1,minText="1个", maxText="10个", tooltipText = "设置动态文字的大小"};
SCTOptionsFrameSliders ["ROTATION"] = {  title = "动画旋转角度", minValue = 0, maxValue = 355, valueStep = 5,minText="0 度", maxText="355 度", tooltipText = "旋转动态文字的移动轨迹角度"};

SCTOptionsColorPickerEx = { };
SCTOptionsColorPickerEx ["SPELLALERT_MOB_COLOR"] = { title = "施放者颜色"};
SCTOptionsColorPickerEx ["SPELLALERT_SPELL_COLOR"] = { title = "法术名颜色"};