--------------------------------------------------------------------------------------
-- 这个是大脚的鼠标信息提示增强插件
-- Copyright@www.ngacn.com
-- Author:独孤傲雪
-- 2006.12.22
-- 这里是BFTT的控制界面部分
---------------------------------------------------------------------------------------
-- 这只是作为一个示例而已
BigFootConfig={};
BigFootConfig.BFTT = 1;
local BFTT_Info_Text;

BFTT_Loaded = nil;

if (GetLocale() == "zhCN") then
	BFTT_Anchor_Text = {
		[1] = NONE,
		[2] = "鼠标",
		[3] = "左上",
		[4] = "顶部",
		[5] = "右上",
		[6] = "左侧",
		[7] = "中心",
		[8] = "右侧",
		[9] = "左下",
		[10] = "底部",
		[11] = "右下",
	};
	BFTT_Rank_Text = {
		[1] = "文字",
		[2] = "图标",
	};
	BFTT_Normal_Text = {
		[1] = "显示",
		[2] = "隐藏",
	};	
	BFTT_Titile = {
		[1] = "提示位置:",
		[2] = "X轴偏移:",
		[3] = "Y轴偏移:",
		[4] = "渐隐提示:",
		[5] = "军衔信息:",
		[6] = "公会信息:",
		[7] = "尸体信息:",
		[8] = "目标的目标:",
		[9] = "PvP:",
	};	
elseif (GetLocale() == "zhTW") then
	BFTT_Anchor_Text = {
		[1] = NONE,
		[2] = "鼠標",
		[3] = "左上",
		[4] = "頂部",
		[5] = "右上",
		[6] = "左側",
		[7] = "中心",
		[8] = "右側",
		[9] = "左下",
		[10] = "底部",
		[11] = "右下",
	};
	BFTT_Rank_Text = {
		[1] = "文字",
		[2] = "圖標",
	};
	BFTT_Normal_Text = {
		[1] = "顯示",
     	[2] = "隱藏",
	};	
	BFTT_Titile = {
		[1] = "提示位置:",
		[2] = "X軸偏移:",
		[3] = "Y軸偏移:",
		[4] = "漸隱提示:",
		[5] = "軍銜信息:",
		[6] = "公會信息:",
		[7] = "屍體信息:",
		[8] = "目標的目標:",
		[9] = "PvP:",
	};
else
	BFTT_Anchor_Text = {
		[1] = NONE,
		[2] = "Following Mouse",
		[3] = "Top Left",
		[4] = "Top",
		[5] = "Top Right",
		[6] = "Left",
		[7] = "Center",
		[8] = "Right",
		[9] = "Bottom Left",
		[10] = "Bottom",
		[11] = "Bottom Right",
	};
	BFTT_Rank_Text = {
		[1] = "Text",
		[2] = "Texture",
	};
	BFTT_Normal_Text = {
		[1] = "Show",
		[2] = "Hide",
	};	
	BFTT_Titile = {
		[1] = "Position:",
		[2] = "PositionX:",
		[3] = "PositionY:",
		[4] = "Fade:",
		[5] = "Rank:",
		[6] = "Guild:",
		[7] = "Corpse:",
		[8] = "ToT:",
		[9] = "PvP:",
	};
end
local function BFTT_GetInitText()
	BFTT_Info_Text = {
		[10] = BFTT_Anchor_Text[BFTT_Config["Anchor"]],
		[11] = BFTT_Config["PositionX"],
		[12] = BFTT_Config["PositionY"],
		[13] = BFTT_Normal_Text[BFTT_Config["Fade"]],
		[14] = BFTT_Rank_Text[BFTT_Config["Rank"]],
		[15] = BFTT_Normal_Text[BFTT_Config["Guild"]],
		[16] = BFTT_Normal_Text[BFTT_Config["Corpse"]],
		[17] = BFTT_Normal_Text[BFTT_Config["TOT"]],
		[18] = BFTT_Normal_Text[BFTT_Config["PVP"]],
	};
end
---------------------------------------------------------------------------------------
-- 配置部分
---------------------------------------------------------------------------------------
local BFTT_Option = {
	[1] = function (fontstr, type)
		if (type == 1) then	
			BFTT_Config["Anchor"] = BFTT_Config["Anchor"]+1;
			if (BFTT_Config["Anchor"] > 11) then
				BFTT_Config["Anchor"] = 1;
			end
		else
			BFTT_Config["Anchor"] = BFTT_Config["Anchor"]-1;
			if (BFTT_Config["Anchor"] < 1) then
				BFTT_Config["Anchor"] = 11;
			end
		end
		fontstr:SetText(BFTT_Anchor_Text[BFTT_Config["Anchor"]])
		end;
	[2] = function (fontstr, type)
		if (type == 1) then	
			BFTT_Config["PositionX"] = BFTT_Config["PositionX"]+1;
		else
			BFTT_Config["PositionX"] = BFTT_Config["PositionX"]-1;
		end
		fontstr:SetText(BFTT_Config["PositionX"]);
	end;
	[3] = function (fontstr, type)
		if (type == 1) then	
			BFTT_Config["PositionY"] = BFTT_Config["PositionY"] + 1;
		else
			BFTT_Config["PositionY"] = BFTT_Config["PositionY"] - 1;
		end
		fontstr:SetText(BFTT_Config["PositionY"]);
	end;
	[4] = function (fontstr, type)
		if (type == 1) then	
			BFTT_Config["Fade"] = BFTT_Config["Fade"] + 1;
			if (BFTT_Config["Fade"] > 2) then
				BFTT_Config["Fade"] = 1;
			end
		else
			BFTT_Config["Fade"] = BFTT_Config["Fade"] - 1;
			if (BFTT_Config["Fade"] < 1) then
				BFTT_Config["Fade"] = 2;
			end
		end
		fontstr:SetText(BFTT_Normal_Text[BFTT_Config["Fade"]]);
	end;
		[5] = function (fontstr, type)
		if (type == 1) then	
			BFTT_Config["Rank"] = BFTT_Config["Rank"] + 1;
			if (BFTT_Config["Rank"] > 2) then
				BFTT_Config["Rank"] = 1;
			end
		else
			BFTT_Config["Rank"] = BFTT_Config["Rank"] - 1;
			if (BFTT_Config["Rank"] < 1 ) then
				BFTT_Config["Rank"] = 2;
			end
		end
		fontstr:SetText(BFTT_Rank_Text[BFTT_Config["Rank"]]);
	end;
	[6] = function (fontstr, type)
		if (type == 1) then	
			BFTT_Config["Guild"] = BFTT_Config["Guild"] + 1;
			if (BFTT_Config["Guild"] > 2) then
				BFTT_Config["Guild"] = 1;
			end
		else
			BFTT_Config["Guild"] = BFTT_Config["Guild"] - 1;
			if (BFTT_Config["Guild"] < 1) then
				BFTT_Config["Guild"] = 2;
			end
		end
		fontstr:SetText(BFTT_Normal_Text[BFTT_Config["Guild"]]);
	end;
	[7] = function (fontstr, type)
		if (type == 1) then	
			BFTT_Config["Corpse"] = BFTT_Config["Corpse"] + 1;
			if (BFTT_Config["Corpse"] > 2) then
				BFTT_Config["Corpse"] = 1;
			end
		else
			BFTT_Config["Corpse"] = BFTT_Config["Corpse"] - 1;
			if (BFTT_Config["Corpse"] < 1 ) then
				BFTT_Config["Corpse"] = 2;
			end
		end
		fontstr:SetText(BFTT_Normal_Text[BFTT_Config["Corpse"]]);
	end;
	[8] = function (fontstr, type)
		if (type == 1) then	
			BFTT_Config["TOT"] = BFTT_Config["TOT"] + 1;
			if (BFTT_Config["TOT"] > 2) then
				BFTT_Config["TOT"] = 1;
			end
		else
			BFTT_Config["TOT"] = BFTT_Config["TOT"] - 1;
			if (BFTT_Config["TOT"] <1) then
				BFTT_Config["TOT"] = 2;
			end
		end
		fontstr:SetText(BFTT_Normal_Text[BFTT_Config["TOT"]]);
	end;
		[9] = function (fontstr, type)
		if (type == 1) then	
			BFTT_Config["PVP"] = BFTT_Config["PVP"] + 1;
			if (BFTT_Config["PVP"] > 2) then
				BFTT_Config["PVP"] = 1;
			end
		else
			BFTT_Config["PVP"] = BFTT_Config["PVP"] - 1;
			if (BFTT_Config["PVP"] <1) then
				BFTT_Config["PVP"] = 2;
			end
		end
		fontstr:SetText(BFTT_Normal_Text[BFTT_Config["PVP"]]);
	end;
};
local function BFTT_SetTitle(str, index, tab)
	tab = tab or BFTT_Titile;
	str:SetText(tab[index]);
end
--------------------------------------------------------------------------------------
-- 创建标准按钮
--------------------------------------------------------------------------------------
local function BFTT_CreateButton(button, name, parent, type, func,arg1, arg2)
	button = CreateFrame("Button", name, parent);
	button:SetWidth(20);
		button:SetHeight(20);
	if (type == 1) then
		button:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up");
		button:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down");
		button:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Disabled");		
	else
		button:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up");
		button:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down");		
		button:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Disabled");		
	end	
	button:SetHighlightTexture("Interface\\Buttons\\GlowStar");	
	button:RegisterForClicks("LeftButtonUp" ,"RightButtonUp");
	button:SetScript(
		"OnClick", 
		function ()
			func(arg1,arg2);
		end
	);
end
--------------------------------------------------------------------------------------
-- 创建控制面板
--------------------------------------------------------------------------------------
local function BFTT_CreateOptionFrame()		
	local frame = CreateFrame("Frame", "BFTT_OPTION_FRAME", UIParent);
	frame:SetFrameStrata("DIALOG");
	frame:SetToplevel(true);
	frame:SetWidth(240);
	frame:SetHeight(380);
	frame:SetPoint("CENTER",UIParent,"CENTER",0,0);
	local LastFontstr;
	for i=1, 9, 1 do
		local fontstring = frame:CreateFontString("BFTT_OPTION_FONTSTRING"..i,"BACKGROUND"); 
		fontstring:SetFont("Fonts\\FZBWJW.TTF", 14);
		fontstring:SetTextColor(1.0, 0.75, 0.0);
		fontstring:SetWidth(90);
		fontstring:SetHeight(12);
		fontstring:SetNonSpaceWrap(true);
		if (i == 1) then
			fontstring:SetPoint("TOPLEFT",frame,"TOPLEFT",0,-35);
		else
			fontstring:SetPoint("TOPLEFT", LastFontstr,"BOTTOMLEFT",0, -10);
		end		
		LastFontstr = fontstring;
	end
	for i=10, 18, 1 do
		local fontstring = frame:CreateFontString("BFTT_OPTION_FONTSTRING"..i,"BACKGROUND"); 
		fontstring:SetFont("Fonts\\FZBWJW.TTF", 14);
			fontstring:SetTextColor(1.0, 0.75, 0.0);
		fontstring:SetWidth(90);
		fontstring:SetHeight(12);
		fontstring:SetNonSpaceWrap(true);
		if (i == 10) then				
			fontstring:SetPoint("LEFT",getglobal("BFTT_OPTION_FONTSTRING1"),"RIGHT",30,2);
		else			
			fontstring:SetPoint("TOPLEFT",LastFontstr,"BOTTOMLEFT", 0, -10);
		end
		BFTT_SetTitle(fontstring, i, BFTT_Info_Text);
		LastFontstr = fontstring;		
	end
	for j=1, 9, 1 do
		local button;
		BFTT_CreateButton(button, "AFTT_Option_Button"..j, frame, 1, BFTT_Option[j],getglobal("BFTT_OPTION_FONTSTRING"..j+9), 1);	
		getglobal("AFTT_Option_Button"..j):SetToplevel(true);
		getglobal("AFTT_Option_Button"..j):SetPoint("LEFT", getglobal("BFTT_OPTION_FONTSTRING"..j+9), "RIGHT", -5, -2);		
	end
	for i=10, 18, 1 do
		local button;
		BFTT_CreateButton(button, "AFTT_Option_Button"..i, frame, 2, BFTT_Option[i-9],getglobal("BFTT_OPTION_FONTSTRING"..i), 2);
		getglobal("AFTT_Option_Button"..i):SetToplevel(true);
		getglobal("AFTT_Option_Button"..i):SetPoint("RIGHT", getglobal("BFTT_OPTION_FONTSTRING"..i), "LEFT", 0, -2);		
	end
	for i=1, 9, 1 do
		BFTT_SetTitle(getglobal("BFTT_OPTION_FONTSTRING"..i), i);
	end

	frame:Hide();
end

function BFTT_Enable_Options(switch)
	if (switch) then
		for i=1, 18, 1 do
			local button = getglobal("AFTT_Option_Button"..i);
			local text = getglobal("BFTT_OPTION_FONTSTRING"..i);
			button:Enable(); 
			text:SetTextColor(1.0,0.82,0.0);
		end		
	else 
		for i=1, 18, 1 do
			local button = getglobal("AFTT_Option_Button"..i);
			local text = getglobal("BFTT_OPTION_FONTSTRING"..i);
			button:Disable(); 
			text:SetTextColor(0.5,0.5,0.5);
		end		
	end 
end

function BFTT_Init()	
	BFTT_GetInitText();
	BFTT_CreateOptionFrame();				
end

local function BFTT_Config_OnEvent()
	if (event == "ADDON_LOADED" and arg1 == "BFTooltip") then
		BFTT_Init();

		BFTT_Loaded = true;
	end
end

local frame = CreateFrame("Frame",nil,UIParent);
frame:RegisterEvent("ADDON_LOADED");
frame:SetScript("OnEvent",BFTT_Config_OnEvent);