DSCT_SPELLALERT_OPTION = "法术预警选项";

DSCT_OptionCfg_SpellAlert = {
	EventFrames = {
		["SHOWEMOTE"] = { x = 200,y = -65,title = "怪物表情", tooltipText = "显示怪物表情"},
		["SHOWYELL"] = { x = 200,y = -95,title = "怪物喊叫", tooltipText = "显示怪物喊叫"},
		["SHOWSPELLALERT"] = { x = 200,y = -125,title = "显示法术预警", tooltipText = "当敌对生物使用法术等时显示预警信息"},
	},
	ColorPickerEx = {
		["SPELLALERT_MOB_COLOR"] = { x = 200,y = -155,title = "施放者颜色"},
		["SPELLALERT_SPELL_COLOR"] = { x = 200,y = -185,title = "法术名颜色"},
	},
	
	CheckButtons = {
		["SHOWSPELLTIMER"] = { x = 195,y = -215,title = "法术预警显示施法时间", tooltipText = "法术预警后面显示施法时间，当然这个时间并不是绝对准确"},
		["SHORTALERT"] = { x = 195,y = -245,title = "简略方式显示预警", tooltipText = "简略方式显示，只显示法术名"},
		["SHOWSA_BEGINCAST"] = { x = 195,y = -275,title = "预警“开始施放”", tooltipText = "法术预警显示开始施放的法术"},
		["SHOWSA_CAST"] = { x = 195,y = -305,title = "预警“施放了”", tooltipText = "法术预警显示瞬发的法术"},
		["SHOWSA_GAIN"] = { x = 195,y = -335,title = "预警“效果获得”", tooltipText = "法术预警显示效果获得"},
	},
}

DSCT_CastTime = {
		-- All Classes
			-- General
		["炉石"] = {t=10.0};
		
			-- Trinkets & Racials
		["脆弱护甲"] = {t=20.0};
		["能量无常"] = {t=20.0};
		["充沛之力"] = {t=20.0};
		["短暂强力"] = {t=15.0};
		["奥术强化"] = {t=20.0};
		["大规模杀伤性魔法"] = {t=20.0};
		["奥术能量"] = {t=20.0};
		["能量护盾"] = {t=20.0};
		["辉煌之光"] = {t=20.0};
		["亡灵意志"] = {t=5.0};
		["感知"] = {t=20.0};
		["战争践踏"] = {t=1.5};
		["石像形态"] = {t=8.0};
		["暗影守卫"] = {t=1.5};
		["狂暴"] = {t=10.0};
			
			-- First Aid
		["亚麻绷带"] = {t=3.0};
		["厚亚麻绷带"] = {t=3.0};
		["绒线绷带"] = {t=3.0};
		["厚绒线绷带"] = {t=3.0};
		["丝质绷带"] = {t=3.0};
		["厚丝质绷带"] = {t=3.0};
		["魔纹绷带"] = {t=3.0};
		["厚魔纹绷带"] = {t=3.0};
		["符文布绷带"] = {t=3.0};
		["厚符文布绷带"] = {t=3.0};
	
		-- Warlock
		["暗影箭"] = {t=2.5};
		["献祭"] = {t=1.5};
		["灵魂之火"] = {t=4.0};
		["灼热之痛"] = {t=1.5};
		["召唤恐惧战马"] = {t=3.0};
		["召唤地狱战马"] = {t=3.0};
		["召唤小鬼"] = {t=10.0};
		["召唤魅魔"] = {t=10.0};
		["召唤虚空行者"] = {t=10.0};
		["召唤地狱猎犬"] = {t=10.0};
		["恐惧术"] = {t=1.5};
		["恐惧嚎叫"] = {t=2.0};
		["放逐术"] = {t=1.5};
		["召唤仪式"] = {t=5.0};

			-- Imp
			["火焰箭"] = {t=2.0};
			
			-- Succubus
			["诱惑"] = {t=1.5};
			["安抚之吻"] = {t=4.0};
		
		
		-- Mage
		["寒冰箭"] = {t=2.5};
		["火球术"] = {t=2.5};
		["造水术"] = {t=2.5};
		["造食术"] = {t=2.5};
		["制造魔法红宝石"] = {t=3.0};
		["制造魔法黄水晶"] = {t=3.0};
		["制造魔法翡翠"] = {t=3.0};
		["制造魔法玛瑙"] = {t=3.0};
		["变形术"] = {t=1.5};
		["炎爆术"] = {t=6.0};
		["灼烧"] = {t=1.5};
		["烈焰风暴"] = {t=3.0};
		["缓落术"] = {t=30.0};

		-- Paladin
		["圣光术"] = {t=2.5};
		["圣光闪现"] = {t=1.5};
		["召唤战马"] = {t=3.0};
		["召唤军马"] = {t=3.0};
		["愤怒之锤"] = {t=1.0};
		["神圣愤怒"] = {t=2.0};
		["超度亡灵"] = {t=1.5};
		["救赎"] = {t=10.0};
		
		-- Priest
		["强效治疗术"] = {t=3.0};
		["快速治疗"] = {t=1.5};
		["复活术"] = {t=10.0};
		["能量猛击"] = {t=2.5};
		["心灵震爆"] = {t=1.5};
		["心灵控制"] = {t=3.0};
		["法力燃烧"] = {t=3.0};
		["神圣之火"] = {t=5.0};
		["安抚心灵"] = {t=1.5};
		["治疗祷言"] = {t=3.0};
		["束缚亡灵"] = {t=1.5};
		
		-- Druid
		["治疗之触"] = {t=3.5};
		["愈合"] = {t=1.5};
		["复生"] = {t=2.0};
		["星火术"] = {t=3.5};
		["愤怒"] = {t=2.0};
		["纠缠根须"] = {t=2.0};
		["急奔"] = {t=15.0};
		["休眠"] = {t=1.5};
		["安抚动物"] = {t=1.5};
		["树皮术"] = {t=15.0, i=0.0, c="cooldown"};
		["激活"] = {t=20.0, i=0.0, c="cooldown"};
		

		-- Shaman
		["次级治疗波"] = {t=1.5};
		["治疗波"] = {t=3.0};
		["先祖之魂"] = {t=10.0};
		["闪电链"] = {t=2.5};
		["幽魂之狼"] = {t=3.0};
		["星界传送"] = {t=10.0};
		["治疗链"] = {t=2.5};
		["闪电箭"] = {t=3.0};
		
		-- Hunter
		["瞄准射击"] = {t=3.0};
		["恐吓野兽"] = {t=1.5};
		["乱射"] = {t=6.0};
		
		-- Rogue
		["解除陷阱"] = {t=5.0};
		["疾跑"] = {t=15.0};
		
		-- Warrior
		["血性狂暴"] = {t=10.0};
		["盾墙"] = {t=10.0};
		["鲁莽"] = {t=15.0};
		["狂暴之怒"] = {t=10.0};
		
		["末日降临"] = {t=20.0, c="cooldown", m="鲁西弗隆"};
		["鲁西弗隆的诅咒"] = {t=20.0, c="cooldown", m="鲁西弗隆"};
	
		-- Magmadar
		["恐慌"] = {t=30.0, c="cooldown", m="玛格曼达"};

		-- Gehennas
		["基赫纳斯的诅咒"] = {t=30.0, c="cooldown", m="基赫纳斯"};

		-- Majordomo
		["魔法反射"] = {t=10.0, i=10.0, c="cooldown", m="管理者埃克索图斯"};
		["伤害反射护盾"] = {t=10.0, i=10.0, c="cooldown", m="管理者埃克索图斯"};
		
		-- Ragnaros
		["拉格纳罗斯消失"] = {t=180.0, c="cooldown"};
		["群体击退"] = {t=28.0, c="cooldown"};
		["烈焰之子"] = {t=90.0, c="cooldown"};
		
		
	-- Blackwing Lair
			
		-- Firemaw/Flamegor/Ebonroc
		["龙翼打击"] = {t=32.0};
		["暗影烈焰"] = {t=2.0};
		
		-- Chromaggus
		["冰霜燃烧"] = {t=60.0};
		["时光流逝"] = {t=60.0};
		["点燃躯体"] = {t=60.0};
		["腐蚀酸液"] = {t=60.0};
		["焚烧"] = {t=60.0};
		
		-- Neferian
		["低沉咆哮"] = {t=2.0};
		["Class Call"] = {t=33.0};
		["Mob Spawn"] = {t=10.0};
};
